# 《设计数据密集应用》 

* 作者： Martin Kleppmann
* 原书名称：《Designing Data-Intensive Application》
* 译者：冯若航 （fengruohang@outlook.com , http://vonng.com/about）
* 建议本地使用[Typora](https://www.typora.io)以获取最佳阅读体验。




## 前言

> 在我们的社会中，技术是一种强大的力量。数据、软件、通信可以用于坏的方面：不公平的阶级固化，损害公民权利，保护既得利益集团。但也可以用于好的方面：让底层人民发出自己的声音，让每个人都拥有机会，避免灾难。本书献给所有将技术用于善途的人们。



> 计算是一种流行文化，流行文化鄙视历史。 流行文化关乎个体身份和参与感，与合作无关。它活在当下，也与过去和未来无关。 我认为大部分（为钱）写代码的人就是这样， 他们不知道他们的文化来自哪里。
>
> ​                          ——阿兰·凯接受Dobb博士的杂志采访时（2012年）



## 目录

### [序言](preface.md)

### [数据系统的基石](part-i.md)

1. [可靠性、可扩展性、可维护性](ch1.md)
2. [数据模型与查询语言](ch2.md)
3. [存储与检索](ch3.md) 
4. [编码与演化](ch4.md)

### [分布式数据](part-ii.md)

5. [复制](ch5.md) 
6. [分片](ch6.md) 
7. [事务](ch7.md) 
8. [分布式系统的麻烦](ch8.md) 
9. [一致性与共识](ch9.md) 

### [衍生数据](part-iii.md)

10. [批处理](ch10.md) 
11. [流处理](ch11.md) 
12. [数据系统的未来](ch12.md) 




## 翻译计划

机翻：股沟翻译，整理图片、引用、备注与基本的排版，不对照着原文基本没法看。

初翻：人工修复格式错误和显著翻译错误，重新组织语言，保障基本的可读性。

精翻：确定一些术语的最终译法，保证可以流畅阅读，着力信达雅。

翻译完全看心情，但通常每周至少会完成一章的初翻。

| 章节   | 文件   | 计划 | 进度 |
| ------ | ------ | ---- | ---- |
| 序     | [preface.md](preface.md) |      | 机翻 |
| 第一部分：数据系统基础 ——概览 | [part-i.md](part-i.md) |      | 精翻 20% |
| 第一章：可靠性、可扩展性、可维护性 | [ch1.md](ch1.md) |      | 初翻 |
| 第二章：数据模型与查询语言 | [ch2.md](ch2.md) |      | 初翻 |
| 第三章：存储与检索 | [ch3.md](ch3.md) |      | 初翻 |
| 第四章：编码与演化 | [ch4.md](ch4.md) |      | 初翻 |
| 第二部分：分布式数据——概览 | [part-ii.md](part-ii.md) | | 初翻 |
| 第五章：复制 | [ch5.md](ch5.md) |      | 初翻 |
| 第六章：分片 | [ch6.md](ch6.md) |      | 初翻 |
| 第七章：事务 | [ch7.md](ch7.md) |      | 初翻 |
| 第八章：分布式系统的麻烦 | [ch8.md](ch8.md) |      | **机翻 0%** |
| 第九章：一致性与共识 | [ch9.md](ch9.md) |      |  |
| 第三部分：前言 | [part-iii.md](part-iii.md) | | 机翻 |
| 第十章：批处理 | [ch10.md](ch10.md) |  | - |
| 第十一章：流处理 | [ch11.md](ch11.md) |      | - |
| 第十二章：数据系统的未来 | [ch12.md](ch12.md) |      | - |




## 译者声明

纯粹出于学习目的与个人兴趣翻译，仅供交流讨论与个人学习使用，闷声发大财自己看就行，严禁用于商业目的与公开传播发行。侵删。目前尚无中文译本，有能力阅读英文书籍者请购买原版支持。

```
《中华人民共和国著作权法》
第四节 权利的限制
第二十二条　在下列情况下使用作品，可以不经著作权人许可，不向其支付报酬，但应当指明作者姓名、作品名称，并且不得侵犯著作权人依照本法享有的其他权利：
(六)为学校课堂教学或者科学研究，翻译或者少量复制已经发表的作品，供教学或者科研人员使用，但不得出版发行;
```

![](img/title.png)